; Copyright (C) 2018 Jerome Shidel
;
;   This program is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation; either version 2 of the License, or
;   (at your option) any later version.
;
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License along
;   with this program; if not, write to the Free Software Foundation, Inc.,
;   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

; NASM 2.14rc0 for DOS

; -----------------------------------------------------------------------------
; FORWARD
; -----------------------------------------------------------------------------

%ifidn CODE_STAGE, BLOCK_FORWARD

; ES:SI --> Source String
; DS:DI --> Destination String
; on output:
; DS:DI --> end of Destination String.
; ES:SI --> After end of source
%imacro CopyAsciiZ 0
    %idefine REQUIRE_CopyAsciiZ
    call    FUNCTION_CopyAsciiZ
%endmacro

%imacro StrExpand 3
    forward StrExpand, %1, %2, %3
%endmacro

%endif

; -----------------------------------------------------------------------------
; CODE - Forward macro support code
; -----------------------------------------------------------------------------

%ifidni CODE_STAGE, BLOCK_CODE

%ifdef REQUIRE_CopyAsciiZ
FUNCTION_CopyAsciiZ:
    es      lodsb
    mov     [di], al
    cmp     al, 0x00
    je      .Done
    inc     di
    jmp     FUNCTION_CopyAsciiZ
.Done:
    ret

%endif

%ifdef REQUIRE_StrExpand
    procedure   StrExpand
;    registers   si, di, bx
;        .Looping:
;            lodsb
;            cmp     al, 0
;            je      .Done
;            call    bx
;            jmp     .Looping
;        .Done:
    endproc     StrExpand
%endif

%endif

; -----------------------------------------------------------------------------
; String and general resource area for built in macros
; -----------------------------------------------------------------------------

%ifidni CODE_STAGE, BLOCK_RESOURCES

%endif

; -----------------------------------------------------------------------------
; Miscellaneous data area for built in macros
; -----------------------------------------------------------------------------

%ifidni CODE_STAGE, BLOCK_DATA

%endif

; -----------------------------------------------------------------------------
; Begin uninitialized data section
; -----------------------------------------------------------------------------

%ifidni CODE_STAGE, BLOCK_BSS

%endif

